"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Api = (function () {
    function Api(baseUrl) {
        if (baseUrl === void 0) { baseUrl = ""; }
        this.baseUrl = baseUrl;
    }
    Api.prototype.login = function (base, expires) {
        var headers = {
            Authorization: "Basic " + base,
        };
        var data = {};
        if (expires) {
            data.expires = expires;
        }
        return this.post("auth/login/", data, headers);
    };
    Api.prototype.logout = function () {
        return this.post("auth/logout/");
    };
    Api.prototype.logoutAll = function () {
        return this.post("auth/logoutall/");
    };
    Api.prototype.usernameAvailable = function (username) {
        return this.get("username-available/" + username + "/");
    };
    Api.prototype.lookupUserID = function (email) {
        return this.post("lookup-user-id/", { email: email });
    };
    Api.prototype.createUser = function (user) {
        return this.post("users/", user);
    };
    Api.prototype.updateUser = function (id, user) {
        return this.patch("users/" + id + "/", user);
    };
    Api.prototype.getUser = function () {
        return __awaiter(this, void 0, void 0, function () {
            var users;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.get("users/")];
                    case 1:
                        users = _a.sent();
                        return [2, users[0]];
                }
            });
        });
    };
    Api.prototype.deleteUser = function (userId, password) {
        return this.delete("users/" + userId + "/", { password: password });
    };
    Api.prototype.getPublicAuth = function (username) {
        return this.get("user-public-auth/" + username + "/");
    };
    Api.prototype.getUserPublicKey = function (id) {
        return this.get("user-public-key/" + id + "/");
    };
    Api.prototype.createGroup = function (group) {
        return this.post("groups/", group);
    };
    Api.prototype.updateGroup = function (id, group) {
        return this.patch("groups/" + id + "/", group);
    };
    Api.prototype.deleteGroup = function (id) {
        return this.delete("groups/" + id + "/");
    };
    Api.prototype.getGroup = function (id) {
        return this.get("groups/" + id + "/");
    };
    Api.prototype.getGroups = function () {
        return this.get("groups/");
    };
    Api.prototype.createGroupUser = function (groupID, groupUser) {
        return this.post("groups/" + groupID + "/users/", groupUser);
    };
    Api.prototype.deleteGroupUser = function (groupID, id) {
        return this.delete("groups/" + groupID + "/users/" + id + "/");
    };
    Api.prototype.acceptGroupInvite = function (groupUserId) {
        return this.post("accept-group-invite/", { id: groupUserId });
    };
    Api.prototype.declineGroupInvite = function (groupUserId) {
        return this.post("reject-group-invite/", { id: groupUserId });
    };
    Api.prototype.getContacts = function () {
        return this.get("contacts/");
    };
    Api.prototype.createSecret = function (secret) {
        return this.post("secrets/", secret);
    };
    Api.prototype.updateSecret = function (id, secret) {
        return this.patch("secrets/" + id + "/", secret);
    };
    Api.prototype.updateSecretWithThroughs = function (id, secret) {
        return this.put("secrets/" + id + "/", secret);
    };
    Api.prototype.getSecret = function (id) {
        return this.get("secrets/" + id + "/");
    };
    Api.prototype.getSecrets = function () {
        return this.get("secrets/");
    };
    Api.prototype.deleteSecret = function (id) {
        return this.delete("secrets/" + id + "/");
    };
    Api.prototype.createSecretGroup = function (secretID, secretGroup) {
        return this.post("secrets/" + secretID + "/groups/", secretGroup);
    };
    Api.prototype.deleteSecretGroup = function (secretID, secretThroughID) {
        return this.delete("secrets/" + secretID + "/groups/" + secretThroughID + "/");
    };
    Api.prototype.changePassword = function (changePassword) {
        return this.post("change-password/", changePassword);
    };
    Api.prototype.confirmEmailLongCode = function (code) {
        return this.put("confirm-email-long-code/", { long_code: code });
    };
    Api.prototype.confirmEmailShortCode = function (code) {
        return this.put("confirm-email-short-code/", { short_code: code });
    };
    Api.prototype.requestNewConfirmation = function () {
        return this.get("request-new-confirmation/");
    };
    Api.prototype.getConf = function () {
        return this.get("conf/");
    };
    Api.prototype.sendInner = function (method, url, body, headers, returnsJSON) {
        return __awaiter(this, void 0, void 0, function () {
            var resp;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, fetch(url, { body: JSON.stringify(body), headers: headers, method: method })];
                    case 1:
                        resp = _a.sent();
                        if (!(resp.status < 200 || resp.status >= 300)) return [3, 3];
                        return [4, resp.json()];
                    case 2: throw _a.sent();
                    case 3:
                        if (!returnsJSON) return [3, 5];
                        return [4, resp.json()];
                    case 4: return [2, _a.sent()];
                    case 5: return [2, undefined];
                }
            });
        });
    };
    Api.prototype.get = function (url) {
        return this.send("GET", url);
    };
    Api.prototype.post = function (url, body, headers) {
        return this.send("POST", url, { body: body, headers: headers });
    };
    Api.prototype.patch = function (url, body) {
        return this.send("PATCH", url, { body: body });
    };
    Api.prototype.put = function (url, body) {
        return this.send("PUT", url, { body: body });
    };
    Api.prototype.delete = function (url, body) {
        var config = { returnsJSON: false };
        if (body) {
            config.body = body;
        }
        return this.send("DELETE", url, config);
    };
    Api.prototype.send = function (method, url, _a) {
        var _b = _a === void 0 ? {} : _a, body = _b.body, _c = _b.returnsJSON, returnsJSON = _c === void 0 ? true : _c, headers = _b.headers;
        var defaultHeaders = {};
        if (returnsJSON) {
            defaultHeaders.Accept = "application/json";
        }
        if (body) {
            defaultHeaders["Content-Type"] = "application/json";
        }
        if (this.token) {
            defaultHeaders.Authorization = "Token " + this.token;
        }
        return this.sendInner(method, this.baseUrl + url, body, Object.assign(defaultHeaders, headers), returnsJSON);
    };
    return Api;
}());
exports.default = Api;
//# sourceMappingURL=api.js.map