"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var exceptions_1 = require("./exceptions");
function authRequired(target, key, descriptor) {
    return {
        descriptor: descriptor,
        value: function () {
            if (!this._check_if_authenticated()) {
                return Promise.reject(new exceptions_1.AuthenticationRequiredException(key));
            }
            return descriptor.value.apply(this, arguments);
        },
    };
}
exports.authRequired = authRequired;
//# sourceMappingURL=decorators.js.map