"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var asymmetric_encryption_1 = require("simple-asymmetric-js/js/asymmetric_encryption");
var crypto_1 = require("simple-asymmetric-js/js/crypto");
var api_1 = require("./api");
var constants_1 = require("./constants");
var decorators_1 = require("./decorators");
var hash_1 = require("./hash");
var utils_1 = require("./utils");
function assignDefined(target, source) {
    for (var key in source) {
        if (source.hasOwnProperty(key)) {
            var val = source[key];
            if (val !== undefined) {
                target[key] = val;
            }
        }
    }
}
function toMap(o) {
    var m = new Map();
    for (var key in o) {
        if (o.hasOwnProperty(key)) {
            m.set(key, o[key]);
        }
    }
    return m;
}
function fromMap(m) {
    var o = {};
    m.forEach(function (v, k) { return o[k] = v; });
    return o;
}
function mapKeys(m, fn) {
    function transformPair(_a) {
        var k = _a[0], v = _a[1];
        return [k, fn(v)];
    }
    return new Map(Array.from(m.entries(), transformPair));
}
function encodeAuthBase64(s) {
    return new asymmetric_encryption_1.Base64Binary(new asymmetric_encryption_1.UTF8Binary(s).binary).string;
}
function decodeSymKeyLegacy(s) {
    if (s.binary.length === 44) {
        return new asymmetric_encryption_1.SymmetricKey(new asymmetric_encryption_1.UTF8Binary(s.binary).string);
    }
    return s;
}
function decodePrivateKeyLegacy(p) {
    if (p.binary.length === 44) {
        return new asymmetric_encryption_1.PrivateKey(new asymmetric_encryption_1.UTF8Binary(p.binary).string);
    }
    return p;
}
var PassitSDK = (function () {
    function PassitSDK() {
        this.api = new api_1.default(constants_1.API_URL);
    }
    PassitSDK.prototype.set_up = function (publicKey, privateKey, userId, authToken) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, asymmetric_encryption_1.sodium.ready];
                    case 1:
                        _a.sent();
                        this.userId = userId;
                        this.api.token = authToken;
                        this.set_keys(publicKey, privateKey);
                        return [2];
                }
            });
        });
    };
    PassitSDK.prototype.set_url = function (url) {
        this.api.baseUrl = url;
    };
    PassitSDK.prototype.ready = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, asymmetric_encryption_1.sodium.ready];
                    case 1: return [2, _a.sent()];
                }
            });
        });
    };
    PassitSDK.prototype.set_keys = function (publicKey, privateKey) {
        this.keyPair = new asymmetric_encryption_1.KeyPair(new asymmetric_encryption_1.PublicKey(publicKey), new asymmetric_encryption_1.PrivateKey(privateKey));
    };
    PassitSDK.prototype.get_conf = function () {
        return this.api.getConf();
    };
    PassitSDK.prototype.is_username_available = function (email) {
        return __awaiter(this, void 0, void 0, function () {
            var available;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.api.usernameAvailable(email)];
                    case 1:
                        available = (_a.sent()).available;
                        return [2, available];
                }
            });
        });
    };
    PassitSDK.prototype.sign_up = function (email, password, firstName, lastName) {
        if (firstName === void 0) { firstName = ""; }
        if (lastName === void 0) { lastName = ""; }
        return __awaiter(this, void 0, void 0, function () {
            var hashObj, _a, publicKey, privateKey, backupCode, privateKeyBackup, res;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4, asymmetric_encryption_1.sodium.ready];
                    case 1:
                        _b.sent();
                        hashObj = hash_1.hashPassword(password);
                        this.keyPair = asymmetric_encryption_1.KeyPair.generate();
                        _a = this.keyPair, publicKey = _a.publicKey, privateKey = _a.privateKey;
                        backupCode = crypto_1.makeRandomTypableString();
                        privateKeyBackup = new asymmetric_encryption_1.Password(backupCode).encrypt(privateKey).string;
                        return [4, this.api.createUser({
                                client_salt: hashObj.salt,
                                email: email,
                                password: hashObj.hash,
                                private_key: new asymmetric_encryption_1.Password(password).encrypt(privateKey).string,
                                public_key: publicKey.string,
                                private_key_backup: privateKeyBackup,
                            })];
                    case 2:
                        _b.sent();
                        return [4, this.do_log_in(email, hashObj.hash, password)];
                    case 3:
                        res = _b.sent();
                        return [2, __assign({}, res, { backupCode: backupCode })];
                }
            });
        });
    };
    PassitSDK.prototype.log_in = function (email, password, expires) {
        return __awaiter(this, void 0, void 0, function () {
            var client_salt, hash;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, asymmetric_encryption_1.sodium.ready];
                    case 1:
                        _a.sent();
                        return [4, this.api.getPublicAuth(email)];
                    case 2:
                        client_salt = (_a.sent()).client_salt;
                        hash = hash_1.hashPassword(password, client_salt).hash;
                        return [2, this.do_log_in(email, hash, password, expires)];
                }
            });
        });
    };
    PassitSDK.prototype.logout = function () {
        return this.api.logout();
    };
    PassitSDK.prototype.logoutAll = function () {
        return this.api.logoutAll();
    };
    PassitSDK.prototype.update_user = function (id, user) {
        return this.api.updateUser(id, user);
    };
    PassitSDK.prototype.confirm_email_long_code = function (code) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.api.confirmEmailLongCode(code)];
                    case 1: return [2, (_a.sent()).user_id];
                }
            });
        });
    };
    PassitSDK.prototype.confirm_email_short_code = function (code) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.api.confirmEmailShortCode(code)];
                    case 1: return [2, (_a.sent()).user_id];
                }
            });
        });
    };
    PassitSDK.prototype.request_new_confirmation = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.api.requestNewConfirmation()];
                    case 1: return [2, (_a.sent())];
                }
            });
        });
    };
    PassitSDK.prototype.lookup_user_id = function (email) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.api.lookupUserID(email)];
                    case 1: return [2, (_a.sent()).id];
                }
            });
        });
    };
    PassitSDK.prototype.deleteOwnAccount = function (password) {
        return __awaiter(this, void 0, void 0, function () {
            var user, hash;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, this.api.getUser()];
                    case 1:
                        user = _a.sent();
                        hash = hash_1.hashPassword(password, user.client_salt).hash;
                        return [2, this.api.deleteUser(this.userId, hash)];
                }
            });
        });
    };
    PassitSDK.prototype.create_group = function (name, slug) {
        if (slug == null) {
            slug = utils_1.slugify(name);
        }
        var _a = asymmetric_encryption_1.KeyPair.generate(), privateKey = _a.privateKey, publicKey = _a.publicKey;
        var _b = this.generateGroupKey(privateKey, this.keyPair.publicKey), key_ciphertext = _b.key_ciphertext, private_key_ciphertext = _b.private_key_ciphertext;
        return this.api.createGroup({
            key_ciphertext: key_ciphertext.string,
            name: name,
            private_key_ciphertext: private_key_ciphertext.string,
            public_key: publicKey.string,
            slug: slug,
        });
    };
    PassitSDK.prototype.update_group = function (_a) {
        var id = _a.id, name = _a.name, slug = _a.slug;
        return this.api.updateGroup(id, { name: name, slug: slug });
    };
    PassitSDK.prototype.delete_group = function (groupId) {
        return this.api.deleteGroup(groupId);
    };
    PassitSDK.prototype.get_group = function (groupID) {
        return this.api.getGroup(groupID);
    };
    PassitSDK.prototype.acceptGroupInvite = function (groupUserId) {
        return this.api.acceptGroupInvite(groupUserId);
    };
    PassitSDK.prototype.declineGroupInvite = function (groupUserId) {
        return this.api.declineGroupInvite(groupUserId);
    };
    PassitSDK.prototype.list_groups = function () {
        return this.api.getGroups();
    };
    PassitSDK.prototype.add_user_to_group = function (groupID, userID, email) {
        return __awaiter(this, void 0, void 0, function () {
            var privateKey, _a, userPubKey, _b, _c, key_ciphertext, private_key_ciphertext;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _a = this._getGroupKeyPair;
                        return [4, this.api.getGroup(groupID)];
                    case 1:
                        privateKey = _a.apply(this, [_d.sent()]).privateKey;
                        _b = asymmetric_encryption_1.PublicKey.bind;
                        return [4, this.api.getUserPublicKey(userID)];
                    case 2:
                        userPubKey = new (_b.apply(asymmetric_encryption_1.PublicKey, [void 0, (_d.sent()).public_key]))();
                        _c = this.generateGroupKey(privateKey, userPubKey), key_ciphertext = _c.key_ciphertext, private_key_ciphertext = _c.private_key_ciphertext;
                        return [2, this.api.createGroupUser(groupID, {
                                key_ciphertext: key_ciphertext.string,
                                private_key_ciphertext: private_key_ciphertext.string,
                                user: userID,
                                user_email: email,
                            })];
                }
            });
        });
    };
    PassitSDK.prototype.remove_user_from_group = function (groupId, groupUserId) {
        return this.api.deleteGroupUser(groupId, groupUserId);
    };
    PassitSDK.prototype.list_contacts = function () {
        return this.api.getContacts();
    };
    PassitSDK.prototype.create_secret = function (secret) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, encryptedKey, encrSecrets, _b, _c, _d, _e;
            return __generator(this, function (_f) {
                switch (_f.label) {
                    case 0:
                        _b = this._encrypt_secrets;
                        _c = [mapKeys(toMap(secret.secrets || {}), function (s) { return new asymmetric_encryption_1.UTF8Binary(s); })];
                        if (!secret.group_id) return [3, 2];
                        _e = asymmetric_encryption_1.PublicKey.bind;
                        return [4, this.get_group(secret.group_id)];
                    case 1:
                        _d = new (_e.apply(asymmetric_encryption_1.PublicKey, [void 0, (_f.sent()).public_key]))();
                        return [3, 3];
                    case 2:
                        _d = undefined;
                        _f.label = 3;
                    case 3:
                        _a = _b.apply(this, _c.concat([_d])), encryptedKey = _a[0], encrSecrets = _a[1];
                        return [2, this.api.createSecret({
                                data: secret.visible_data || {},
                                name: secret.name || "",
                                secret_through_set: [{
                                        data: fromMap(mapKeys(encrSecrets, function (s) { return s.string; })),
                                        group: secret.group_id,
                                        key_ciphertext: encryptedKey.string,
                                    }],
                                type: secret.type,
                            })];
                }
            });
        });
    };
    PassitSDK.prototype.update_secret = function (secret) {
        return __awaiter(this, void 0, void 0, function () {
            var patchSecret, dbSecret, _i, _a, secretThrough, _b, encryptedKey, encrSecrets;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        patchSecret = {
                            name: secret.name,
                            type: secret.type,
                            data: secret.visible_data,
                        };
                        if (!!secret.secrets) return [3, 2];
                        return [4, this.api.updateSecret(secret.id, patchSecret)];
                    case 1: return [2, _c.sent()];
                    case 2: return [4, this.get_secret(secret.id)];
                    case 3:
                        dbSecret = _c.sent();
                        assignDefined(dbSecret, patchSecret);
                        for (_i = 0, _a = dbSecret.secret_through_set; _i < _a.length; _i++) {
                            secretThrough = _a[_i];
                            _b = this._encrypt_secrets(mapKeys(toMap(secret.secrets), function (s) { return new asymmetric_encryption_1.UTF8Binary(s); }), new asymmetric_encryption_1.PublicKey(secretThrough.public_key)), encryptedKey = _b[0], encrSecrets = _b[1];
                            secretThrough.data = fromMap(mapKeys(encrSecrets, function (s) { return s.string; }));
                            secretThrough.key_ciphertext = encryptedKey.string;
                        }
                        return [4, this.api.updateSecretWithThroughs(secret.id, dbSecret)];
                    case 4: return [2, _c.sent()];
                }
            });
        });
    };
    PassitSDK.prototype.delete_secret = function (secretID) {
        return this.api.deleteSecret(secretID);
    };
    PassitSDK.prototype.get_secret = function (secretID) {
        return this.api.getSecret(secretID);
    };
    PassitSDK.prototype.list_secrets = function () {
        return this.api.getSecrets();
    };
    PassitSDK.prototype.decrypt_secret = function (uniqueSecret) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, key_ciphertext, data, group, decrypted, _b, _c, _d, _e;
            return __generator(this, function (_f) {
                switch (_f.label) {
                    case 0:
                        _a = uniqueSecret.secret_through_set.find(function (through) { return through.is_mine === true; }), key_ciphertext = _a.key_ciphertext, data = _a.data, group = _a.group;
                        _b = this._decrypt_secrets;
                        _c = [new asymmetric_encryption_1.Encrypted(key_ciphertext),
                            mapKeys(toMap(data), function (s) { return new asymmetric_encryption_1.Encrypted(s); })];
                        if (!group) return [3, 2];
                        _e = this._getGroupKeyPair;
                        return [4, this.api.getGroup(group)];
                    case 1:
                        _d = _e.apply(this, [_f.sent()]);
                        return [3, 3];
                    case 2:
                        _d = undefined;
                        _f.label = 3;
                    case 3:
                        decrypted = _b.apply(this, _c.concat([_d]));
                        return [2, fromMap(mapKeys(decrypted, function (s) { return s.string; }))];
                }
            });
        });
    };
    PassitSDK.prototype.offline_decrypt_secret = function (keyCiphertext, data, group) {
        var decrypted = this._decrypt_secrets(new asymmetric_encryption_1.Encrypted(keyCiphertext), mapKeys(toMap(data), function (s) { return new asymmetric_encryption_1.Encrypted(s); }), group ? this._getGroupKeyPair(group) : undefined);
        return fromMap(mapKeys(decrypted, function (s) { return s.string; }));
    };
    PassitSDK.prototype.add_group_to_secret = function (groupId, secret) {
        return __awaiter(this, void 0, void 0, function () {
            var public_key, decryptedSecrets, _a, encryptedKey, encryptedSecrets;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!(typeof secret === "number")) return [3, 2];
                        return [4, this.get_secret(secret)];
                    case 1:
                        secret = _b.sent();
                        _b.label = 2;
                    case 2: return [4, this.get_group(groupId)];
                    case 3:
                        public_key = (_b.sent()).public_key;
                        return [4, this.decrypt_secret(secret)];
                    case 4:
                        decryptedSecrets = _b.sent();
                        return [4, this._encrypt_secrets(mapKeys(toMap(decryptedSecrets), function (s) { return new asymmetric_encryption_1.UTF8Binary(s); }), new asymmetric_encryption_1.PublicKey(public_key))];
                    case 5:
                        _a = _b.sent(), encryptedKey = _a[0], encryptedSecrets = _a[1];
                        return [4, this.api.createSecretGroup(secret.id, {
                                data: fromMap(mapKeys(encryptedSecrets, function (s) { return s.string; })),
                                group: groupId,
                                key_ciphertext: encryptedKey.string,
                            })];
                    case 6: return [2, _b.sent()];
                }
            });
        });
    };
    PassitSDK.prototype.remove_group_from_secret = function (secretId, secretThroughId) {
        return this.api.deleteSecretGroup(secretId, secretThroughId);
    };
    PassitSDK.prototype.change_password = function (oldPassword, newPassword) {
        return __awaiter(this, void 0, void 0, function () {
            var user, oldHash, newUserKeyPair, secretThroughSet, groupUserSet, _a, hash, salt;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4, this.api.getUser()];
                    case 1:
                        user = _b.sent();
                        oldHash = hash_1.hashPassword(oldPassword, user.client_salt).hash;
                        newUserKeyPair = asymmetric_encryption_1.KeyPair.generate();
                        return [4, this.reencryptSecretThroughSet(newUserKeyPair)];
                    case 2:
                        secretThroughSet = _b.sent();
                        return [4, this.reencryptGroupUserSet(newUserKeyPair)];
                    case 3:
                        groupUserSet = _b.sent();
                        _a = hash_1.hashPassword(newPassword), hash = _a.hash, salt = _a.salt;
                        return [4, this.api.changePassword({
                                old_password: oldHash,
                                user: {
                                    client_salt: salt,
                                    password: hash,
                                    public_key: newUserKeyPair.publicKey.string,
                                    private_key: new asymmetric_encryption_1.Password(newPassword).encrypt(newUserKeyPair.privateKey).string,
                                },
                                secret_through_set: secretThroughSet,
                                group_user_set: groupUserSet,
                            })];
                    case 4:
                        _b.sent();
                        return [2];
                }
            });
        });
    };
    PassitSDK.prototype.reencryptSecretThroughSet = function (userKeyPair) {
        return __awaiter(this, void 0, void 0, function () {
            var secretThroughSet, _i, _a, secret, _b, _c, secretThrough, unencryptedData, _d, encryptedKey, encryptedSecrets;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        secretThroughSet = [];
                        _i = 0;
                        return [4, this.list_secrets()];
                    case 1:
                        _a = _e.sent();
                        _e.label = 2;
                    case 2:
                        if (!(_i < _a.length)) return [3, 4];
                        secret = _a[_i];
                        for (_b = 0, _c = secret.secret_through_set; _b < _c.length; _b++) {
                            secretThrough = _c[_b];
                            if (secretThrough.is_mine && secretThrough.group === null) {
                                unencryptedData = this._decrypt_secrets(new asymmetric_encryption_1.Encrypted(secretThrough.key_ciphertext), mapKeys(toMap(secretThrough.data), function (s) { return new asymmetric_encryption_1.Encrypted(s); }));
                                _d = this._encrypt_secrets(unencryptedData, userKeyPair.publicKey), encryptedKey = _d[0], encryptedSecrets = _d[1];
                                secretThroughSet.push(__assign({ hash: hash_1.MD5(secretThrough.key_ciphertext) }, secretThrough, { data: fromMap(mapKeys(encryptedSecrets, function (s) { return s.string; })), key_ciphertext: encryptedKey.string }));
                            }
                        }
                        _e.label = 3;
                    case 3:
                        _i++;
                        return [3, 2];
                    case 4: return [2, secretThroughSet];
                }
            });
        });
    };
    PassitSDK.prototype.reencryptGroupUserSet = function (userKeyPair) {
        return __awaiter(this, void 0, void 0, function () {
            var groupUserSet, _i, _a, group, _b, _c, groupUser, groupKeyPair, newGroupKeys;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        groupUserSet = [];
                        _i = 0;
                        return [4, this.list_groups()];
                    case 1:
                        _a = _d.sent();
                        _d.label = 2;
                    case 2:
                        if (!(_i < _a.length)) return [3, 7];
                        group = _a[_i];
                        _b = 0, _c = group.groupuser_set;
                        _d.label = 3;
                    case 3:
                        if (!(_b < _c.length)) return [3, 6];
                        groupUser = _c[_b];
                        if (!(groupUser.user === this.userId)) return [3, 5];
                        return [4, this._getGroupKeyPair(group)];
                    case 4:
                        groupKeyPair = _d.sent();
                        newGroupKeys = this.generateGroupKey(groupKeyPair.privateKey, userKeyPair.publicKey);
                        groupUserSet.push(__assign({ hash: hash_1.MD5(group.my_key_ciphertext) }, groupUser, { private_key_ciphertext: newGroupKeys.private_key_ciphertext.string, key_ciphertext: newGroupKeys.key_ciphertext.string }));
                        _d.label = 5;
                    case 5:
                        _b++;
                        return [3, 3];
                    case 6:
                        _i++;
                        return [3, 2];
                    case 7: return [2, groupUserSet];
                }
            });
        });
    };
    PassitSDK.prototype._check_if_authenticated = function () {
        if (this.userId) {
            return true;
        }
        return false;
    };
    PassitSDK.prototype._decrypt_secrets = function (encryptedKey, encryptedSecret, keyPair) {
        if (!keyPair) {
            keyPair = this.keyPair;
        }
        var key = decodeSymKeyLegacy(keyPair.decrypt(encryptedKey, asymmetric_encryption_1.SymmetricKey));
        return mapKeys(encryptedSecret, function (s) { return key.decrypt(s, asymmetric_encryption_1.UTF8Binary); });
    };
    PassitSDK.prototype._getGroupKeyPair = function (group) {
        var encrSymKey = new asymmetric_encryption_1.Encrypted(group.my_key_ciphertext);
        var symKey = decodeSymKeyLegacy(this.keyPair.decrypt(encrSymKey, asymmetric_encryption_1.SymmetricKey));
        var encrPrivKey = new asymmetric_encryption_1.Encrypted(group.my_private_key_ciphertext);
        var privateKey = decodePrivateKeyLegacy(symKey.decrypt(encrPrivKey, asymmetric_encryption_1.PrivateKey));
        return new asymmetric_encryption_1.KeyPair(new asymmetric_encryption_1.PublicKey(group.public_key), privateKey);
    };
    PassitSDK.prototype.generateGroupKey = function (groupPrivateKey, userPublicKey) {
        var symKey = asymmetric_encryption_1.SymmetricKey.generate();
        var encryptedGroupPrivateKey = symKey.encrypt(groupPrivateKey);
        var encryptedGroupAESKey = userPublicKey.encrypt(symKey);
        return {
            key_ciphertext: encryptedGroupAESKey,
            private_key_ciphertext: encryptedGroupPrivateKey,
        };
    };
    PassitSDK.prototype._encrypt_secrets = function (secrets, publicKey) {
        if (!publicKey) {
            publicKey = this.keyPair.publicKey;
        }
        var key = asymmetric_encryption_1.SymmetricKey.generate();
        var encryptedSecrets = mapKeys(secrets, function (s) { return key.encrypt(s); });
        key = new asymmetric_encryption_1.SymmetricKey((new asymmetric_encryption_1.UTF8Binary(key.string)).binary);
        var encryptedKey = publicKey.encrypt(key);
        return [encryptedKey, encryptedSecrets];
    };
    PassitSDK.prototype.do_log_in = function (email, hash, password, expires) {
        return __awaiter(this, void 0, void 0, function () {
            var base, _a, token, user, encrPrivKey, privateKey;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        base = encodeAuthBase64(email + ":" + hash);
                        return [4, this.api.login(base, expires)];
                    case 1:
                        _a = _b.sent(), token = _a.token, user = _a.user;
                        this.api.token = token;
                        this.userId = user.id;
                        encrPrivKey = new asymmetric_encryption_1.Encrypted(user.private_key);
                        privateKey = new asymmetric_encryption_1.Password(password).decrypt(encrPrivKey);
                        this.keyPair = new asymmetric_encryption_1.KeyPair(new asymmetric_encryption_1.PublicKey(user.public_key), privateKey);
                        return [2, {
                                user: user,
                                token: token,
                                privateKey: this.keyPair.privateKey.string,
                            }];
                }
            });
        });
    };
    __decorate([
        decorators_1.authRequired
    ], PassitSDK.prototype, "update_user", null);
    __decorate([
        decorators_1.authRequired
    ], PassitSDK.prototype, "create_group", null);
    __decorate([
        decorators_1.authRequired
    ], PassitSDK.prototype, "update_group", null);
    __decorate([
        decorators_1.authRequired
    ], PassitSDK.prototype, "delete_group", null);
    __decorate([
        decorators_1.authRequired
    ], PassitSDK.prototype, "get_group", null);
    __decorate([
        decorators_1.authRequired
    ], PassitSDK.prototype, "acceptGroupInvite", null);
    __decorate([
        decorators_1.authRequired
    ], PassitSDK.prototype, "declineGroupInvite", null);
    __decorate([
        decorators_1.authRequired
    ], PassitSDK.prototype, "list_groups", null);
    __decorate([
        decorators_1.authRequired
    ], PassitSDK.prototype, "add_user_to_group", null);
    __decorate([
        decorators_1.authRequired
    ], PassitSDK.prototype, "remove_user_from_group", null);
    __decorate([
        decorators_1.authRequired
    ], PassitSDK.prototype, "list_contacts", null);
    __decorate([
        decorators_1.authRequired
    ], PassitSDK.prototype, "create_secret", null);
    __decorate([
        decorators_1.authRequired
    ], PassitSDK.prototype, "update_secret", null);
    __decorate([
        decorators_1.authRequired
    ], PassitSDK.prototype, "delete_secret", null);
    __decorate([
        decorators_1.authRequired
    ], PassitSDK.prototype, "get_secret", null);
    __decorate([
        decorators_1.authRequired
    ], PassitSDK.prototype, "list_secrets", null);
    __decorate([
        decorators_1.authRequired
    ], PassitSDK.prototype, "decrypt_secret", null);
    __decorate([
        decorators_1.authRequired
    ], PassitSDK.prototype, "add_group_to_secret", null);
    __decorate([
        decorators_1.authRequired
    ], PassitSDK.prototype, "remove_group_from_secret", null);
    __decorate([
        decorators_1.authRequired
    ], PassitSDK.prototype, "change_password", null);
    return PassitSDK;
}());
exports.default = PassitSDK;
//# sourceMappingURL=sdk.js.map